package Flock;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.util.Vector;
import java.awt.*;


/**
 * Flock, Clase Fundamental el el proyecto. Junta y simula la actuasion
 * de cada objeto.
 * 
 */
public class Flock {


    private Vector birds;
    
    static int SeparationRange;
    
    static int DetectionRange;
    

    private static Dimension map = new Dimension( 500, 500 );
    
    /**
     * Constructor.
     * 
     */
    Flock()
    {
        birds = new Vector(40, 10);
    }
	
  
    

    /**
     * Agrega Obejtos al vector
     * @param Bird
     */
    public void addBird(Bird bird) {
        birds.addElement(bird);
    }
    
   /**
     * Elimina Objetos de un Color. No usado en esta version
     * @param  Color del tipo de objeto a eliminar
     */
    synchronized void retirarBird(Color color) {
        for (int i=0; i < birds.size(); i++) {
            Bird bird = (Bird)birds.elementAt(i);
            if (bird.getColor() == color) {
                birds.removeElementAt(i);
                break;
            }
        }
    }
    
    /**
     * Actualiza todos los aprametros de un tipo de Bird. No utilizada
     *
     * @param  Color. Tipo de bird a actualizar
     * @param  velocidad. Velocidad del Bird
     * @param  rotacion, capacidad del Bird para maniobrar
     */
    public void setiarparametrosBird( Color color, int Velocidad, int rotacion ) {
        for (int i=0; i < birds.size(); i++) {
            Bird bird = (Bird)birds.elementAt(i);
            if (bird.getColor() == color) {
                bird.setSpeed( Velocidad );
                bird.setMaxRotacion( rotacion );
            }
        }
    }
    
    /**
     * La hambre de los depredadores. No usada ya que la primera version no edita parametros.
     * se espera mejorar la interfaz.
     *
     * @param  hambre, por defecto en 1, cuantos birds se como el depradador antes de retirarse
     */
    public void setHambre( int hambre ) {
        for (int i=0; i < birds.size(); i++) {
            Bird bird = (Bird)birds.elementAt(i);
            if (bird instanceof Predator ) {
                Predator p = (Predator) bird;
                p.setHambre( hambre );
            }
        }
    }
    
     /**
     * Set the new size of the area where 
     *
     * @param  otherBird The other bird to measure the distance between
     */
    static void setMapSize(Dimension newSize) {
        map = newSize;
    }
        
    /**
     * The display function simply draws each Bird in the vector based on 
     * its current position and direction (theta).
     */
    public void draw(Graphics g) {
        for (int i=0; i < birds.size(); i++) {
            Bird bird = (Bird)birds.elementAt(i);
            bird.draw(g);
         
        }
    }
    
    /**
     * Entonces Birds, muevanse
     * Revisa todo el Flock y mueve cada Bird, Asegura que Bird se alimentaron y cuales se retiran.
     * @return  entrega un vector de todos los Bird que se retiraron, el cual solo ayuda en la interfaz.
     */
    synchronized public Vector move() {
    	
        boolean predatorIsFull = false;
        boolean ateBird = false;
        
        int movingBird = 0;
        int birdToEat = 0;
        
        Vector removedBirds = new Vector( 2, 1 );
        
        
        while (movingBird < birds.size()) {
            predatorIsFull = false;
            ateBird = false;
            
            Bird bird = (Bird)birds.elementAt(movingBird);
            bird.move(generalHeading(bird)); //estudiar
            
            birdToEat = 0;

            while (birdToEat < birds.size()) {
                Bird otherBird = (Bird)birds.elementAt(birdToEat);
                
               
                if ((movingBird != birdToEat) &&
                            (bird.getLocation().x > otherBird.getLocation().x - 2) &&
                            (bird.getLocation().x < otherBird.getLocation().x + 2) &&
                            (bird.getLocation().y > otherBird.getLocation().y - 2) &&
                            (bird.getLocation().y < otherBird.getLocation().y + 2)) {
                    
                   
                    if (((bird instanceof Predator) && (otherBird.getClass().equals(Bird.class))) || (otherBird instanceof Food)) {
                        birds.removeElement(otherBird);
                        removedBirds.addElement(otherBird);
                        ateBird = true;

                       
                        if (bird instanceof Predator) {
                            Predator predator = (Predator) bird;
                            predator.eatBird();

                          
                            if (predator.getHunger() <= 0)
                            {
                                birds.removeElement(bird);
                                removedBirds.addElement(bird);
                                predatorIsFull = true;
                            }
                        }

                        break;
                    }
                }
                birdToEat++;
            }
            boolean ateBirdBeforeCurrent = ( ateBird ) && ( birdToEat < movingBird );
            if (ateBirdBeforeCurrent && predatorIsFull) {
                
                movingBird--;
            }
            else if (!ateBirdBeforeCurrent && !predatorIsFull) {
                
                 movingBird++;
            }
        }
        
        return removedBirds;
    }
    
    /**
     * Para nuestro algoritmo de Flock, un punto puede tener mas peso que otro por el
     * echo de que los objetos se atrae o repelen, tambien por la distancia en que esten. 
     * Funcion basada en tutoriales
     *
     * @param  p1 un punto
     * @param  w1 su importancia
     * @param  p2 segundo punto
     * @param  w2 su importancia
     * @return un punto que se usa como vector.
     */
    public Point sumPoints(Point p1, double w1, Point p2, double w2) {
        return new Point((int)(w1*p1.x + w2*p2.x), (int)(w1*p1.y + w2*p2.y));
    }
 
    /**
     * Distancia del punto usado como vector
     * @param  p punto a evaluar.
     * @return distancia del punto
     */
    public double sizeOfPoint(Point p) {
        return Math.sqrt(Math.pow(p.x, 2) + Math.pow(p.y, 2));
    }
 
    /**
     * normalisar un punto, usado como vector. Basado en tutoriales
     *
     * @param  p punto a normalisar.
     * @param  n valor de narmolisar.
     * @return punto usado como vector.
     */
    public Point normalisePoint(Point p, double n) {
        if (sizeOfPoint(p) == 0.0) {
            return p;
        }
        else {
            double weight = n / sizeOfPoint(p);
            return new Point((int)(p.x * weight), (int)(p.y * weight));
        }
    }
    
    /**
     * Manejo de vectores y puntos. Basado en tutoriales
     *
     * @param  p punto a analisar.
     * @param  otherPoint es el otro punto a evaluar.
     * @return punto que se espera usar como vector
     */
    public Point closestLocation(Point p, Point otherPoint) {
        int dX = Math.abs(otherPoint.x - p.x);
        int dY = Math.abs(otherPoint.y - p.y);
        int x = otherPoint.x;
        int y = otherPoint.y;
        
        if ( Math.abs(map.width - otherPoint.x + p.x) < dX ) {
            dX = map.width - otherPoint.x + p.x;
            x = otherPoint.x - map.width;
        }
        if ( Math.abs(map.width - p.x + otherPoint.x) < dX ) {
            dX = map.width - p.x + otherPoint.x;
            x = otherPoint.x + map.width;
        }
        
        if ( Math.abs(map.height - otherPoint.y + p.y) < dY ) {
            dY = map.height - otherPoint.y + p.y;
            y = otherPoint.y - map.height;
        }
        if ( Math.abs(map.height - p.y + otherPoint.y) < dY ) {
            dY = map.height - p.y + otherPoint.y;
            y = otherPoint.y + map.height;
        }
        
        return new Point( x, y );
    }
 
    /** 
     * Clase Fundamental, Analisa la direccion que debe tomar cada mienbro del flock
     * en cada iterasion.  Metodo basado a base de tutoriales y manejo de vectores.
     * 2 de un mismo tipo se acercan.
     * Depredador vs Bird se acerca.
     * Bird vs comida Se acerca.
     * 2 de distinto tipo se alejan.
     *
     * @param  Bird a analisar
     * @return  grados 
     */
    private int generalHeading(Bird bird) {
        if ((bird instanceof Obstacle) || (bird instanceof Food)) {
            return 0;   
        }
        
        Point target = new Point(0, 0);
        
        int numBirds = 0;
        
        for (int i=0; i < birds.size(); i++) {
            Bird otherBird = (Bird)birds.elementAt(i);
            Point otherLocation = closestLocation(bird.getLocation(), otherBird.getLocation());
            
            int distance = bird.getDistance(otherLocation);
            
            if (!bird.equals(otherBird) && distance > 0 && distance <= DetectionRange)
            {
                
                if (bird.getColor().equals(otherBird.getColor())) { 
                    Point align = new Point((int)(100 * Math.cos(otherBird.getTheta() * Math.PI/180)),
                    (int)(-100 * Math.sin(otherBird.getTheta() * Math.PI/180)));
                    align = normalisePoint(align, 100); 
                    boolean tooClose = (distance < SeparationRange);
                    double weight = 200.0;
                    if (tooClose) {
                        weight *= Math.pow(1 - (double) distance / SeparationRange, 2);
                    }
                    else {
                        weight *= - Math.pow((double)( distance - SeparationRange ) / ( DetectionRange - SeparationRange ), 2);
                    }
                    Point attract = sumPoints(otherLocation, -1.0, bird.getLocation(), 1.0);
                    attract = normalisePoint(attract, weight); 
                    Point dist = sumPoints(align, 1.0, attract, 1.0);
                    dist = normalisePoint(dist, 100); 
                    target = sumPoints(target, 1.0, dist, 1.0);
                }
                
                else if ((bird instanceof Predator) && (otherBird.getClass().equals(Bird.class))) {
                    Point dist = sumPoints(bird.getLocation(), -1.0, otherLocation, 1.0);
                    dist = normalisePoint(dist, 1000);
                    double weight = 1;
                    target = sumPoints(target, 1.0, dist, weight); 
                }
                
                else if (otherBird instanceof Food) {
                    Point dist = sumPoints(bird.getLocation(), -1.0, otherLocation, 1.0);
                    dist = normalisePoint(dist, 1000);
                    double weight = 1;
                    target = sumPoints(target, 1.0, dist, weight); 
                }
                
                else {
                    Point dist = sumPoints(bird.getLocation(), 1.0, otherLocation, -1.0);
                    dist = normalisePoint(dist, 1000);
                    double weight = Math.pow((1 - (double)distance/DetectionRange), 2);
                    target = sumPoints(target, 1.0, dist, weight); // weight is variable
                }
                numBirds++;
            }
        }
         if (numBirds == 0) {
            return bird.getTheta();
        }
        else { 
            target = sumPoints(bird.getLocation(), 1.0, target, 1/(double)numBirds);
        }
        
        int targetTheta = (int)(180/Math.PI * Math.atan2(bird.getLocation().y - target.y, target.x - bird.getLocation().x));
        
        return (targetTheta + 360) % 360;
    }
	
	
	
}
