package Flock;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JPanel;

/**
 * 
 * @author      Lukas Perez
 * @version     1.0
 */

public class Simulador extends Applet implements Runnable,ActionListener{

	//Constantes
	
	public static final int separateDistance=100;
	public static final int detectDistance=150;
	
	
	public static final int greenBirdSpeed=5;
	public static final int greenBirdMaxTheta=20;
	public static final int blueBirdSpeed=4;
	public static final int blueBirdMaxTheta=40;
	public static final int redBirdSpeed=10;
	public static final int redBirdMaxTheta=10;
	
	
	
	private JButton botton1,botton2,botton3,botton4,botton5;
	
	SimuladorCamvas camvas;
	
	JPanel controls;
	
	public Flock flock;
	
	Thread thread;
	
	boolean mostrarRangos;
	
	/**
     * Iniciando Applet
     * 
     */
	
	public void init(){
		
		mostrarRangos=false;
		this.resize(500,500);
		camvas=new SimuladorCamvas(this);
		controls = new JPanel();
		
		controls.setLayout(new GridLayout(1,4));
		botton1=new JButton("Verde");
		botton2=new JButton("Azul");
		botton3=new JButton("Rojo");
		botton4=new JButton("Reset");
		botton5=new JButton("Rangos");
		
		controls.add(botton1);
		controls.add(botton2);
		controls.add(botton3);
		controls.add(botton4);
		controls.add(botton5);
		
		botton1.addActionListener((ActionListener) this);
		botton2.addActionListener((ActionListener) this);
		botton3.addActionListener((ActionListener) this);
		botton4.addActionListener((ActionListener) this);
		botton5.addActionListener((ActionListener) this);
		
		
		
		
		reset();
		
		setLayout(new BorderLayout());
		
        add("Center", camvas);

        add("North", controls);
		
        camvas.requestFocus();
        
        Bird.setMapSize(camvas.getSize()); 
        Flock.setMapSize(camvas.getSize());
        
	}
	
	/**
     * Rehacer el Flock
     * 
     */
	
	public void reset(){
		
		Bird.SeparationRange = separateDistance;
        Bird.DetectionRange = detectDistance;
        
        flock = new Flock();
        
        Flock.SeparationRange = separateDistance;
        Flock.DetectionRange = detectDistance;
        
        
        
        for (int i=0; i < 4; i++) {
            Bird bird = new Bird(Color.green);
            bird.setSpeed( greenBirdSpeed );
            bird.setMaxRotacion( greenBirdMaxTheta );
            flock.addBird(bird);
            
        }
        for (int i=0; i < 5; i++) {
            Bird bird = new Bird(Color.blue);
            bird.setSpeed( blueBirdSpeed );
            bird.setMaxRotacion( blueBirdMaxTheta );
            flock.addBird(bird);
        }
        
		
	}
	/**
     * Iniciando interfaz
     * 
     */
	public void addControl(JPanel arg){
		arg.setLayout(new GridLayout(1,4));
		botton1=new JButton("Verde");
		botton2=new JButton("Azul");
		botton3=new JButton("Rojo");
		botton4=new JButton("GO!");
		
		arg.add(botton1);
		arg.add(botton2);
		arg.add(botton3);
		arg.add(botton4);
		
		botton1.addActionListener((ActionListener) this);
		botton2.addActionListener((ActionListener) this);
		botton3.addActionListener((ActionListener) this);
		botton4.addActionListener((ActionListener) this);
	}
	
	public void actionPerformed(ActionEvent e){
		if (e.getSource()==botton1){
			Bird b = new Bird(Color.green);
            b.setSpeed( greenBirdSpeed );
            b.setMaxRotacion( greenBirdMaxTheta );
            flock.addBird(b);
		}
		if (e.getSource()==botton2){
			Bird b = new Bird(Color.blue);
            b.setSpeed( blueBirdSpeed );
            b.setMaxRotacion( blueBirdMaxTheta );
            flock.addBird(b);
		}
		if (e.getSource()==botton3){
			Predator b = new Predator();
            b.setSpeed( redBirdSpeed );
            b.setMaxRotacion( redBirdMaxTheta );
            b.setHambre(1);
            flock.addBird(b);
		
		}
		
		if (e.getSource()==botton4){
			reset();
		}
		if (e.getSource()==botton5){
			mostrarRangos=!mostrarRangos;
			Bird.showRanges=mostrarRangos;
		}
	
	}
	
	/**
     * Este applet se vuelve una Hebra
     * 
     */
    public void start() {
        if (thread == null) {
            thread = new Thread(this);
            thread.start();
        }
    }
    
    /**
     * Deteniendo Hebra
     * 
     */
    public void stop() {
        if (thread != null) {
            thread.stop();
            thread = null;
        }
    }
	
    /**
     * Correr el framework
     * 
     */
	public void run() {
        while (true) {
            Bird.setMapSize(camvas.getSize());
            Flock.setMapSize(camvas.getSize());
            Vector removedBirds = flock.move();
            for ( int i = 0; i < removedBirds.size(); i++ ) {
                Bird bird = (Bird)removedBirds.elementAt(i);
               
            }
            
            
            camvas.validate();
            camvas.setVisible(true);
            camvas.repaint();
            
            camvas.invalidate();
            invalidate();
            repaint();
            this.repaint( camvas.getLocation().x, camvas.getLocation().y, camvas.getSize().width, camvas.getSize().height);
            
            try {
                Thread.sleep(20); // interval between steps
            } catch (InterruptedException e) {}
        }
    }
	
	/**
     * Escuchando el mouse
     * 
     */
	public boolean mouseDown(Event ev, int x, int y) {
        if (ev.modifiers == ev.META_MASK ) {
            if ( y > camvas.getLocation().y ) {
                flock.addBird(new Food( x, y - camvas.getLocation().y ));
                return true;
            }
        }
        else {
            if ( y > camvas.getLocation().y ) {
                flock.addBird(new Obstacle( x, y - camvas.getLocation().y ));
                return true;
            }
        }
        return false;
    }
	
}
