package Flock;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;

/**
 * Clase que crea una zona de dibujo
 * 
 */
public class SimuladorCamvas extends Canvas{

	Image canvasImage;
    
    Graphics canvasGraphics;

    Simulador simulador;
	
    public SimuladorCamvas(Simulador arg) {
		
    	simulador = arg;
	}


    
    public synchronized void update(Graphics g) {
        paint(g);
    }
    /**
     * Lo peculiar de este emtodo es que en cada iteracion 
     * obtiene los parametros del porte del applet.
     * Dandole un muy buen manejo del porte de la imagen.
     */
    public synchronized void paint(Graphics g) {
        if (this.getWidth() == 0 ) {
            return;
        }
        if (( canvasImage == null ) ||
                    ( canvasImage.getWidth(this) != this.getWidth() ) ||
                    ( canvasImage.getHeight(this) != this.getHeight() )) {
            if ( canvasGraphics != null ) {
                canvasGraphics.dispose();
            }
            canvasImage = createImage(this.getWidth(), this.getHeight());
            canvasGraphics = canvasImage.getGraphics();
        }

        if ( canvasGraphics != null ) {
            canvasGraphics.setColor(Color.white);
            canvasGraphics.fillRect(0, 0, this.getWidth(), this.getHeight());
            simulador.flock.draw(canvasGraphics);
            this.getGraphics().drawImage(canvasImage, 0, 0, this);
        }
    }
    
}
